import QtQuick 2.0
import QtQuick.Dialogs 1.2
import MuseScore 1.0

MuseScore {

	menuPath: "Plugins.getLyrics.example"
	
	property var sMsg: ""	
	
	function toArray(obj){
		var aout = [];
		for (var i=0;i<obj.length;i++){
			aout.push(obj[i]);
		}
		return aout;
	}

	function repeat(pattern, count) {
		if (count < 1) return '';
		var result = '';
		while (count > 1) {
			if (count & 1) result += pattern;
			count >>= 1, pattern += pattern;
		}
		return result + pattern;
	}

	MessageDialog {
		id: msgBox
		title: "Get Lyrics"
		icon: StandardIcon.Information
		modality: Qt.ApplicationModal
		text: ""
		detailedText: ""
		informativeText: ""
		standardButtons: StandardButton.Ok
		Component.onCompleted: visible = false
		onYes: Qt.quit();
		onRejected: Qt.quit();
	}		
	
	onRun: {
		if (typeof curScore === 'undefined') {
			sMsg = "no Score";
		} else {
			var sc = curScore;
			if (!curScore.hasLyrics){
				sMsg = "no Lyrics";
			} else {
				var sc = curScore;
				var parts = sc.parts;
				var lyrParts = [];
				for (var i = 0; i < parts.length; i++) {
					if (parts[i].lyricCount > 0) lyrParts.push(i);
				}
				var part = parts[lyrParts[0]];
				var track = part.startTrack;
				var strArrLyrics = [];
				var iArrLine = [];
				var seg = sc.firstSegment();
				while(seg) {
					if (seg.segmentType == Segment.ChordRest){
						var elem = seg.elementAt(track);
						if (elem){
							if (elem.type == Element.CHORD){
								var lyr = toArray(elem.lyrics);
								for (var i = 0; i < lyr.length; i++) {
									if (i > strArrLyrics.length-1){
										strArrLyrics.push((i+1)+".\n");
										iArrLine.push(0);
									}
									if (lyr[i]) {
										var sAppend = (lyr[i].syllabic == Lyrics.SINGLE || lyr[i].syllabic == Lyrics.END) ? " ": "-";								
										var len1 = lyr[i].text.length + sAppend.length;
										var len2 = strArrLyrics[i].length;
										sAppend += len1 + len2 - iArrLine[i] > 80 ? "\n" : "";
										iArrLine[i] = len1 + len2 - iArrLine[i] > 80 ? len2: iArrLine[i];
										strArrLyrics[i] += lyr[i].text + sAppend;
									}
								}
							}
						}
					}
					seg = seg.next;
				}
				for(var i = 0; i < strArrLyrics.length; i++){
					sMsg += strArrLyrics[i] + "\n\n";
				}
			}
		}
		msgBox.informativeText = " see Detail \n" + repeat("_",90);                  
		msgBox.detailedText = sMsg;
		msgBox.visible = true;
		Qt.quit();
    }
}
